Subject: bug#63710: use-package not working

From: Andrea Corallo <[email-masked]>
Date: Sun, 28 May 2023 13:30:52 +0000

Andrea Corallo <[email-masked]> writes:

> Pedro Andres Aranda Gutierrez <[email-masked]> writes:
>
>> First: the .emacs.d/init.el test file
>>
>> ------
>> ;;
>> ;; My .emacs file
>> ;;
>> (require 'package)
>> (setq package-archives '(("melpa" . "https://melpa.org/packages/")
>> ("gnu" . "https://elpa.gnu.org/packages/")
>>                          ("melpa-stable" . "https://stable.melpa.org/packages/")
>> ("nongnu" . "https://elpa.nongnu.org/nongnu/")))
>> (eval-when-compile
>>   (require 'use-package))
>> (unless (file-directory-p package-user-dir)
>>     (package-refresh-contents))
>> (require 'use-package-ensure)
>> (setq use-package-always-ensure t)
>>
>> (use-package "compat")
>> ------
>>
>> Second: 1d5b164109b59559d34c545c2a163fa067ca22b2 does work
>>
>> BTW,  it has to do with native compilation. I have accidentally not deleted the eln-cache in on of the tests and the
>> 'wrong' Emacs has started correctly:
>> 1. started 1d5b164109b59559d34c545c2a163fa067ca22b2 with eln-clean cache ---> OK
>> 2. started b2b2be98da5825e6bc130999ffe38f5ed615586a with eln-cache from the last start --> OK
>> 3. started b2b2be98da5825e6bc130999ffe38f5ed615586a with clean eln-cache ---> KO
>
>>>From these SHA1s looks like there's good chance it's my fault...
>
> I'll have a look.

Okay I did some investigation and understood the issue.

`package-load-descriptor' was misscompiled and returning always nil as
the compiler was not fully picking up the user defined types at compile
time, it worked only after the first faulty compilation (thing that made
the investigaiton a bit slower).

I'm working on a more complete fix but this requires careful testing, I
pushed now c8e527cbeee in order to have master stable again while I keep
working on the most comprehensive fix.

Best regards

  Andrea